nqueen_print_all_solutions.cpp File Reference

Eight Queens puzzle, printing all solutions More...

`#include <iostream>`
`#include <array>`
Include dependency graph for nqueen_print_all_solutions.cpp:

## Namespaces

| backtracking
| Backtracking algorithms.
| n_queens_all_solutions
| Functions for Eight Queens puzzle with all solutions.

## Functions

template<size_t n>
void | backtracking::n_queens_all_solutions::PrintSol (const std::array< std::array< int, n >, n > &board)
template<size_t n>
bool | backtracking::n_queens_all_solutions::CanIMove (const std::array< std::array< int, n >, n > &board, int row, int col)
template<size_t n>
void | backtracking::n_queens_all_solutions::NQueenSol (std::array< std::array< int, n >, n > board, int col)
int | main ()

## Detailed Description

Eight Queens puzzle, printing all solutions

Author
  Himani Negi
  David Leal

## Function Documentation

## CanIMove()

template<size_t n>

bool backtracking::n_queens_all_solutions::CanIMove | ( | const std::array< std::array< int, n >, n > & | board,
|  | int | row,
|  | int | col
| ) |  |

Check if a queen can be placed on matrix

Template Parameters

  n | number of matrix size

Parameters

  board | matrix where numbers are saved
  row | current index in rows
  col | current index in columns

Returns
  `true` if queen can be placed on matrix
  `false` if queen can't be placed on matrix

check in the row

check the first diagonal

check the second diagonal

{
/// check in the row
for (int i = 0; i < col; i++) {
if (board[row][i] == 1) {
return false;
}
}
/// check the first diagonal
for (int i = row, j = col; i >= 0 && j >= 0; i--, j--) {
if (board[i][j] == 1) {
return false;
}
}
/// check the second diagonal
for (int i = row, j = col; i <= n - 1 && j >= 0; i++, j--) {
if (board[i][j] == 1) {
return false;
}
}
return true;
}

## main()

int main | ( | void |  | ) |

Main function

{
const int n = 4;
std::array<std::array<int, n>, n> board{0};
backtracking::n_queens_all_solutions::NQueenSol(board, 0);
}
std::array
backtracking::n_queens_all_solutions::NQueenSol
void NQueenSol(std::array< std::array< int, n >, n > board, int col)
Definition: nqueen_print_all_solutions.cpp:79

## NQueenSol()

template<size_t n>

void backtracking::n_queens_all_solutions::NQueenSol | ( | std::array< std::array< int, n >, n > | board,
|  | int | col
| ) |  |

Solve n queens problem

Template Parameters

  n | number of matrix size

Parameters

  board | matrix where numbers are saved
  col | current index in columns

{
if (col >= n) {
PrintSol(board);
return;
}
for (int i = 0; i < n; i++) {
if (CanIMove(board, i, col)) {
board[i][col] = 1;
NQueenSol(board, col + 1);
board[i][col] = 0;
}
}
}
backtracking::n_queens_optimized::PrintSol
void PrintSol(const std::array< std::array< int, n >, n > &board)
Definition: n_queens_all_solution_optimised.cpp:30
backtracking::n_queens_optimized::NQueenSol
void NQueenSol(std::array< std::array< int, n >, n > board, int col)
Definition: n_queens_all_solution_optimised.cpp:89
backtracking::n_queens_optimized::CanIMove
bool CanIMove(const std::array< std::array< int, n >, n > &board, int row, int col)
Definition: n_queens_all_solution_optimised.cpp:59

## PrintSol()

template<size_t n>

void backtracking::n_queens_all_solutions::PrintSol | ( | const std::array< std::array< int, n >, n > & | board | ) |

Utility function to print matrix

Template Parameters

  n | number of matrix size

Parameters

  board | matrix where numbers are saved

{
for (int i = 0; i < n; i++) {
for (int j = 0; j < n; j++) {
std::cout << board[i][j] << " ";
}
std::cout << std::endl;
}
std::cout << std::endl;
}
std::cout
std::endl
T endl(T... args)
Here is the call graph for this function: